Subject: bug#25027: Grep 2.25 misses lines in semi-large file

From: Jim Meyering <[email-masked]>
Date: Fri, 25 Nov 2016 10:13:27 -0800

On Fri, Nov 25, 2016 at 5:25 AM, Mattias Jiderhamn
<[email-masked]> wrote:
> Hi. I'm using grep 2.25 in cygwin on a 17 MB log file. I happened to notice
> that when I did "grep Migrate" on the file some lines were missing. If
> however I did some other filtering first, i.e. "grep foo | grep Migrate"
> (where foo would match those lines), they are included.
>
> I cannot reproduce this issue with grep 2.5.4 on Linux.
>
> I tried minimizing the log file by removing lines that I did not expect in
> the output, but when removing lines before the expected line the problem
> dissappeared, so somewhere in the first 17 MB (of my 50 MB file) there is
> something triggering the bug.
>
> Due to the nature of the logged data, I'm not willing to make the file
> publically available in a bug report, but I'm willing to transfer it to one
> of the maintainers, or by some other means help out in debugging. Please
> suggest how to proceed.

Thank you for the report.

It may be useful to know what locale you are using in those tests.
I.e., what does "locale" print for you? If you're not already using
the "C" locale, can you reproduce the problem with "LC_ALL=C grep
Migrate" ?

If that doesn't help, I'd be happy to investigate. You are welcome to
send me that log file, preferably well-compressed.